<?php

namespace Lc\CaracoleBundle\Container\Product;

use App\Definition\Field\Product\ProductFamilyFieldDefinition;
use Lc\CaracoleBundle\Builder\Product\ProductFamilyBuilder;
use Lc\CaracoleBundle\Factory\Product\ProductFamilyFactory;
use Lc\CaracoleBundle\Factory\Product\ProductFamilySectionPropertyFactory;
use Lc\CaracoleBundle\Repository\Product\ProductFamilyRepositoryQuery;
use Lc\CaracoleBundle\Repository\Product\ProductFamilySectionPropertyRepositoryQuery;
use Lc\CaracoleBundle\Repository\Product\ProductFamilySectionPropertyStore;
use Lc\CaracoleBundle\Repository\Product\ProductFamilyStore;
use Lc\CaracoleBundle\Resolver\ProductFamilyResolver;
use Lc\CaracoleBundle\Solver\Product\ProductFamilySectionPropertySolver;
use Lc\CaracoleBundle\Solver\Product\ProductFamilySolver;

class ProductFamilySectionPropertyContainer
{
    protected ProductFamilySectionPropertyFactory $factory;
    protected ProductFamilySectionPropertySolver $solver;
    protected ProductFamilySectionPropertyRepositoryQuery $repositoryQuery;
    protected ProductFamilySectionPropertyStore $store;

    public function __construct(
        ProductFamilySectionPropertyFactory         $factory,
        ProductFamilySectionPropertySolver          $solver,
        ProductFamilySectionPropertyRepositoryQuery $repositoryQuery,
        ProductFamilySectionPropertyStore           $store
    )
    {
        $this->factory = $factory;
        $this->solver = $solver;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public function getFactory(): ProductFamilySectionPropertyFactory
    {
        return $this->factory;
    }

    public function getSolver(): ProductFamilySectionPropertySolver
    {
        return $this->solver;
    }

    public function getRepositoryQuery(): ProductFamilySectionPropertyRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): ProductFamilySectionPropertyStore
    {
        return $this->store;
    }

}
